import json
import os

import pandas as pd
import matplotlib.pyplot as plt
import seaborn as sns
import numpy as np

sns.set_style('white')

df = pd.read_csv("distdr-training.csv")

print(df['Iteration'])
print(df['DistDR'])
df['Iteration'] = df['Iteration']

plt.gcf()
fig, ax = plt.subplots()

edge_df = pd.DataFrame(
    {'Iteration': df['Iteration'],
     'DistDR': df['DistDR'],
     'DistDR (No Filter)': df['no filter'],
     'DistDR (Answer Filter)': df['answer filter'],
     }).sort_values(by=['Iteration']).reset_index()  # .sort_values(
# by='count').reset_index()
edge_df.plot.line(x='Iteration', y='DistDR', ax=ax,
                  legend=True, fontsize=28, marker='>',markersize=13,color='red')
edge_df.plot.line(x='Iteration', y='DistDR (Answer Filter)', ax=ax,
                  legend=True, fontsize=28, marker='*',markersize=13,color='blue')
edge_df.plot.line(x='Iteration', y='DistDR (No Filter)', ax=ax,
                  legend=True, fontsize=28, marker='o',markersize=13,color='orange')

# edge_df.plot.bar(x='Edge', y='EdgeAccu', ax=ax,
#                   legend=False, fontsize=12)
plt.legend(loc=4, borderaxespad=1.6, fontsize=20)

plt.xlabel("Iteration", fontsize=28)
plt.yticks(np.arange(0, 100, 20))
plt.ylabel("Chain Recall", fontsize=28)
plt.xticks(np.arange(0, 9, 1))
#plt.xlim((0,9))
plt.subplots_adjust(left=0.15, right=0.95, top=0.95, bottom=0.2)
# plt.show()
sns.despine()

plt.savefig("distdr-train.pdf")

